﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using xAPI.Sync;
using xAPI.Responses;
using xAPI.Commands;
using xAPI.Records;
using xAPI.Codes;

namespace xAPITest
{
    class Program
    {
        private static Server serverData = Servers.DEMO;
        private static string userId = "userId";
        private static string password = "password";

        static void Main(string[] args)
        {
            Console.WriteLine("Server address: " + serverData.Address + " port: " + serverData.MainPort + " streaming port: " + serverData.StreamingPort);

            // Connect to server
            SyncAPIConnector connector = new SyncAPIConnector(serverData);
            Console.WriteLine("Connected to the server");

            // Login to server
            Credentials credentials = new Credentials(userId, password, "", "YOUR APP NAME");

            LoginResponse loginResponse = APICommandFactory.ExecuteLoginCommand(connector, credentials, true);
            Console.WriteLine("Logged in as: " + userId);

            // Init streaming
            connector.Streaming.Connect();
            connector.Streaming.SubscribePrice("EURUSD");
            connector.Streaming.TickRecordReceived += Streaming_TickRecordReceived;

            // Get current price
            SymbolResponse symbolResponse = APICommandFactory.ExecuteSymbolCommand(connector, "EURUSD");
            Console.WriteLine("Initial symbol price: " + symbolResponse.Symbol.Ask);

            Console.Read();
        }

        // Callback function
        static void Streaming_TickRecordReceived(StreamingTickRecord tickRecord)
        {
            if (tickRecord.Level == 0)
                Console.WriteLine("Current price: " + tickRecord.Ask);
        }
    }
}
